Search documentation of ssl

# View Source ssl (ssl v11.2.1)

Interface functions for TLS (Transport Layer Security), and DTLS (Datagram Transport Layer Security).

> #### Note

> The applications name is still SSL due to the fact that the first versions of the TLS protcol were named SSL (Secure Socket Layer), however, no version of the old SSL protocol are supported, by this application.

Example:

    1> ssl:start(), ssl:connect("google.com", 443, [{verify, verify_peer},
        {cacerts, public_key:cacerts_get()}]).
    {ok,{sslsocket, [...]}}

See Using SSL for detailed usage and more examples of this API.

Special Erlang node configuration for the application can be found in ssl application reference.

# Summary

## Types: Socket

active_msgs()

When a TLS/DTLS socket is in active mode (the default), data from the socket is delivered to the owner of the socket in the form of messages.

dtls_legacy_version()

DTLS protocol version that for security reason no longer are supported by default.

dtls_version()

DTLS protocol version.

error_alert()

If a TLS connection fails a TLS protocol ALERT will be sent/received.

host()

A name or address to a host.

protocol_extensions()

Client hello extensions.

protocol_version()

TLS or DTLS protocol version.

reason()

Error reason for debug purpose should not be matched.

session_id()

Identifies a TLS session pre TLS-1.3.

socket()

Socket that can be used to perform a so called "START-TLS", that is use an already connected socket that was previously used for plain TCP traffic and can be upgraded to use TLS. Both sides needs to agree on the upgrade.

socket_option()

Options for the transport socket.

sslsocket()

An opaque reference to the TLS/DTLS connection, however it may be used for equality matching.

tls_alert()

TLS Alert Protocol reasons.

tls_client_option()

All options that can be supplied to a TLS client

tls_legacy_version()

TLS protocol version that for security reason no longer are supported by default.

tls_option()

Option related to the TLS/DTLS protocol.

tls_server_option()

All options that can be supplied to a TLS server

tls_version()

TLS protocol version.

transport_option()

Transport option defines a callback module and message tags to handle the underlying transport socket.

## Types: Algorithms

cipher()

Cipher algorithms that can be used for payload encryption.

cipher_filters()

Filter that allows you to customize cipher suite list.

cipher_suites()

A list of cipher suites that should be supported

ciphers()

Cipher suite formats.

erl_cipher_suite()

Erlang cipher suite representation

group()

TLS-1.3 key exchange configuration.

hash()

Hash algorithms used together with signing and encryption functions.

kex_algo()

Cipher Suite Key Exchange Algorithm will be any in TLS-1.3 as key exchange is no longer part of cipher suite configuration in TLS-1.3.

named_curve()

Pre TLS-1.3 key exchange configuration.

rsassa_pss_scheme()

Supported in TLS-1.3 and TLS-1.2.

sha2()

SHA2 hash algorithms.

sign_algo()

Signature algorithms.

sign_scheme()

Signature schemes, defined by TLS-1.3, and replaces signature algorithms from TLS-1.2.

signature_algs()

Explicitly list acceptable signature algorithms for certificates and handshake messages in the preferred order.

srp_param_type()

Pre TLS-1.3 SRP cipher suite configuration.

## Types: Certificates

anchor_fun()

Claim an intermediate CA in the chain as trusted.

cert_key_conf()

Configuration of the entity certificate and its corresponding key.

crl_cache_opts()

Options for using built in CRL cache support.

key()

The user's private key.

## Types: Algorithms Legacy

legacy_cipher()

Cipher algorithms that for security reason no longer are supported by default.

legacy_hash()

Hash algorithms that for security reason no longer are supported by default

legacy_named_curve()

Pre TLS-1.3 key exchange configuration. These curves has been deprecated by RFC 8422.

legacy_sign_algo()

Signature algorithms that for security reasons no longer are supported by default

legacy_sign_scheme()

Only used for certificate signatures if TLS-1.2 is negotiated, that is the peer only supports TLS-1.2 but we support also TLS-1.3.

old_cipher_suite()

For backwards compatibility only, do not use it.

## Types: Client Options

client_option()

Options specific to the client side, or with different semantics for the client and server.

client_option_cert()

Certificate related options specific to the client side, or with different semantics for the client and server.

client_option_legacy()

Legacy client options.

client_option_pre_tls13()

Options only relevant to TLS versions pre TLS-1.3.

client_option_tls13()

Options only relevant for TLS-1.3.

## Types: Server Options

server_option()

Options specific to the server side, or with different semantics for the client and server.

server_option_cert()

Certificate related options.

server_option_legacy()

Legacy server options.

server_option_pre_tls13()

Options only relevant to TLS versions pre TLS-1.3.

server_option_tls13()

Options only relevant for TLS-1.3.

## Types: Client and Server Options

common_option()

Options common to both client and server side.

common_option_cert()

Common certificate related options to both client and server.

common_option_dtls()

Common options to client and server only valid for DTLS.

common_option_legacy()

Legacy options considered deprecated in favour of other options, insecure to use, or plainly not relevant anymore.

common_option_pre_tls13()

Options common to both client and server side pre TLS-1.3.

common_option_tls13()

Common options to both client and server for TLS-1.3.

## Types: Info

connection_info()

Key value list convening some information about the established connection.

connection_info_keys()

TLS connection keys that you can get information about.

connection_info_pre_tls13()

TLS connection information relevant pre TLS-1.3.

security_info()

TLS connection information that can be used for NSS-keyloging.

## Types: Deprecated

prf_random() deprecated

## Client API

connect(TCPSocket, TLSOptions)

Equivalent to `connect(TCPSocket, TLSOptions, infinity)`.

connect(TCPSocketOrHost, TLSOptionsOrPort, TimeoutOrTLSOptions)

Opens a TLS/DTLS connection.

connect(Host, Port, TLSOptions, Timeout)

Opens a TLS/DTLS connection to `Host`, `Port`.

## Server API

handshake(HsSocket)

Performs the TLS/DTLS server-side handshake.

handshake(HsSocket, OptionsOrTimeout)

Performs the TLS/DTLS server-side handshake.

handshake(Socket, Options, Timeout)

Performs the TLS/DTLS server-side handshake.

listen(Port, Options)

Creates an SSL listen socket.

transport_accept(ListenSocket)

Equivalent to `transport_accept(ListenSocket, infinity)`.

transport_accept(ListenSocket, Timeout)

Accepts an incoming connection request on a listen socket.

## Client and Server API

close(SslSocket)

Closes a TLS/DTLS connection.

close(SslSocket, How)

Closes or downgrades a TLS connection.

controlling_process(SslSocket, NewOwner)

Assigns a new controlling process to the SSL socket.

handshake_cancel(Socket)

Cancel the handshake with a fatal `USER_CANCELED` alert.

handshake_continue(HsSocket, Options)

Equivalent to `handshake_continue(HsSocket, Options, infinity)`.

handshake_continue(HsSocket, Options, Timeout)

Continue the TLS handshake, possibly with new, additional or changed options.

recv(SslSocket, Length)

Equivalent to `recv(Socket, Length, infinity)`.

recv(SslSocket, Length, Timeout)

Receives a packet from a socket in passive mode.

send(SslSocket, Data)

Writes `Data` to `SslSocket`.

setopts(SslSocket, Options)

Sets options according to `Options` for socket `SslSocket`.

shutdown(SslSocket, How)

Immediately closes a socket in one or two directions.

## TLS-1.3 Only API

groups()

Returns all supported groups in TLS 1.3. Existed since OTP 22.0 , documented as of OTP 27.

groups(Description)

Returns default supported groups in TLS 1.3. Existed since OTP 22.0, documented as of OTP 27.

update_keys(SslSocket, Type)

Create new session keys.

## Pre TLS-1.3 API

eccs()

Returns a list of all supported elliptic curves, including legacy curves, for all TLS/DTLS versions pre TLS-1.3.

eccs(Version)

Returns the by default supported elliptic curves for Version, which is a subset of what [eccs/[0]] returns.

renegotiate(SslSocket)

Initiates a new handshake.

## Utility Functions

append_cipher_suites(Deferred, Suites)

Make `Deferred` suites become the least preferred suites.

cipher_suites(Description, Version)

Lists all possible cipher suites corresponding to `Description` that are available.

cipher_suites(Description, Version, StringType)

Same as `cipher_suites/2` but lists RFC or OpenSSL string names instead of `erl_cipher_suite/0`

clear_pem_cache()

Clears the PEM cache.

connection_information(SslSocket)

Returns the most relevant information about the connection.

connection_information(SslSocket, Items)

Returns the requested information items about the connection, if they are defined.

export_key_materials(SslSocket, Labels, Contexts, WantedLengths)

Equivalent to `export_key_materials(TLSSocket, Labels, Contexts, WantedLengths, true).`

export_key_materials(SslSocket, Labels, Contexts, WantedLengths, ConsumeSecret)

Uses the Pseudo-Random Function, PRF (pre TLS-1.3) or HKDF (TLS-1.3), for a TLS connection to generate and export keying materials.

filter_cipher_suites(Suites, Filters)

Removes cipher suites if any of the filter functions returns false for any part of the cipher suite.

format_error(Error)

Presents the error returned by an SSL function as a printable string, the error tag may be both included and excluded

getopts(SslSocket, OptionNames)

Gets the values of the specified socket options.

getstat(SslSocket)

Equivalent to `getstat/2`.

getstat(SslSocket, Options)

Gets one or more statistic options for the underlying TCP socket.

negotiated_protocol(SslSocket)

Returns the protocol negotiated through ALPN or NPN extensions.

peercert(SslSocket)

The peer certificate is returned as a DER-encoded binary.

peername(SslSocket)

Returns the address and port number of the peer.

prepend_cipher_suites(Preferred, Suites)

Make `Preferred` suites become the most preferred suites.

signature_algs(Description, Version)

Lists all possible signature algorithms corresponding to `Description` that are available.

sockname(SslSocket)

Returns the local address and port number of socket `SslSocket`.

start()

Equivalent to `start(temporary)`.

start(Type)

Starts the SSL application.

stop()

Stops the SSL application.

str_to_suite(CipherSuiteName)

Converts an RFC or OpenSSL name string to an `erl_cipher_suite/0`

suite_to_openssl_str(CipherSuite)

Converts `erl_cipher_suite/0` to OpenSSL name string.

suite_to_str(CipherSuite)

Converts an `erl_cipher_suite()` value to an RFC name string.

versions()

Lists information, mainly concerning TLS/DTLS versions, in runtime for debugging and testing purposes.

## Deprecated API

prf(SslSocket, Secret, Label, Seed, WantedLength) deprecated

Uses the Pseudo-Random Function (PRF) of a TLS session to generate extra key material.

# Types: Socket

Link to this type

# active_msgs()

View Source

    -type active_msgs() ::
              {ssl, sslsocket(), Data :: binary() | list()} |
              {ssl_closed, sslsocket()} |
              {ssl_error, sslsocket(), Reason :: any()} |
              {ssl_passive, sslsocket()}.

When a TLS/DTLS socket is in active mode (the default), data from the socket is delivered to the owner of the socket in the form of messages.

The `ssl_passive` message is sent only when the socket is in `{active, N}` mode and the counter dropped to 0. It indicates that the socket has transitioned to passive (`{active, false}`) mode.

Link to this type

# dtls_legacy_version()

View Source (not exported)

    -type dtls_legacy_version() :: dtlsv1.

DTLS protocol version that for security reason no longer are supported by default.

Link to this type

# dtls_version()

View Source (not exported)

    -type dtls_version() :: 'dtlsv1.2' | dtls_legacy_version().

DTLS protocol version.

Link to this type

# error_alert()

View Source

    -type error_alert() :: {tls_alert, {tls_alert(), Description :: string()}}.

If a TLS connection fails a TLS protocol ALERT will be sent/received.

An atom reflecting the raised alert, according to the TLS protocol, and a description string with some further details will be returned.

Link to this type

# host()

View Source

    -type host() :: inet:hostname() | inet:ip_address().

A name or address to a host.

Link to this type

# protocol_extensions()

View Source

    -type protocol_extensions() ::
              #{renegotiation_info => binary(),
                signature_algs => signature_algs(),
                alpn => binary(),
                srp => binary(),
                next_protocol => binary(),
                max_frag_enum => 1..4,
                ec_point_formats => [0..2],
                elliptic_curves => [public_key:oid()],
                sni => inet:hostname()}.

Client hello extensions.

Link to this type

# protocol_version()

View Source

    -type protocol_version() :: tls_version() | dtls_version().

TLS or DTLS protocol version.

Link to this type

# reason()

View Source

    -type reason() :: term().

Error reason for debug purpose should not be matched.

Link to this type

# session_id()

View Source

    -type session_id() :: binary().

Identifies a TLS session pre TLS-1.3.

Link to this type

# socket()

View Source

    -type socket() :: gen_tcp:socket().

Socket that can be used to perform a so called "START-TLS", that is use an already connected socket that was previously used for plain TCP traffic and can be upgraded to use TLS. Both sides needs to agree on the upgrade.

Link to this type

# socket_option()

View Source

    -type socket_option() :: gen_tcp:connect_option() | gen_tcp:listen_option() | gen_udp:option().

Options for the transport socket.

The default socket options are `[{mode,list},{packet, 0},{header, 0},{active, true}]`.

For valid options, see the `inet`, `gen_tcp` and `gen_udp` manual pages in Kernel. Note that stream oriented options such as packet are only relevant for TLS and not DTLS.

Link to this type

# sslsocket()

View Source

    -type sslsocket() :: any().

An opaque reference to the TLS/DTLS connection, however it may be used for equality matching.

Link to this type

# tls_alert()

View Source

    -type tls_alert() ::
              close_notify | unexpected_message | bad_record_mac | record_overflow | handshake_failure |
              bad_certificate | unsupported_certificate | certificate_revoked | certificate_expired |
              certificate_unknown | illegal_parameter | unknown_ca | access_denied | decode_error |
              decrypt_error | export_restriction | protocol_version | insufficient_security |
              internal_error | inappropriate_fallback | user_canceled | no_renegotiation |
              unsupported_extension | certificate_unobtainable | unrecognized_name |
              bad_certificate_status_response | bad_certificate_hash_value | unknown_psk_identity |
              no_application_protocol.

TLS Alert Protocol reasons.

Link to this type

# tls_client_option()

View Source

    -type tls_client_option() :: client_option() | common_option() | socket_option() | transport_option().

All options that can be supplied to a TLS client

Link to this type

# tls_legacy_version()

View Source (not exported)

    -type tls_legacy_version() :: tlsv1 | 'tlsv1.1'.

TLS protocol version that for security reason no longer are supported by default.

Link to this type

# tls_option()

View Source

    -type tls_option() :: tls_client_option() | tls_server_option().

Option related to the TLS/DTLS protocol.

Link to this type

# tls_server_option()

View Source

    -type tls_server_option() :: server_option() | common_option() | socket_option() | transport_option().

All options that can be supplied to a TLS server

Link to this type

# tls_version()

View Source (not exported)

    -type tls_version() :: 'tlsv1.2' | 'tlsv1.3' | tls_legacy_version().

TLS protocol version.

Link to this type

# transport_option()

View Source (not exported)

    -type transport_option() ::
              {cb_info,
               {CallbackModule :: atom(), DataTag :: atom(), ClosedTag :: atom(), ErrTag :: atom()}} |
              {cb_info,
               {CallbackModule :: atom(),
                DataTag :: atom(),
                ClosedTag :: atom(),
                ErrTag :: atom(),
                PassiveTag :: atom()}}.

Transport option defines a callback module and message tags to handle the underlying transport socket.

Can be used to customize the transport layer. The tag values should be the values used by the underlying transport in its active mode messages.

Defaults to `{gen_tcp, tcp, tcp_closed, tcp_error, tcp_passive}` for TLS (for backward compatibility a four tuple will be converted to a five tuple with the last element "second_element"_passive) and `{gen_udp, udp, udp_closed, udp_error, udp_passive}`

For TLS the callback module must implement a reliable transport protocol, behave as `gen_tcp`, and have functions corresponding to `inet:setopts/2`, `inet:getopts/2`, `inet:peername/1`, `inet:sockname/1`, and `inet:port/1`. The callback `gen_tcp` is treated specially and calls `inet` directly. For DTLS this feature must be considered experimental.

# Types: Algorithms

Link to this type

# cipher()

View Source

    -type cipher() ::
              aes_256_gcm | aes_128_gcm | aes_256_ccm | aes_128_ccm | chacha20_poly1305 | aes_256_ccm_8 |
              aes_128_ccm_8 | aes_128_cbc | aes_256_cbc |
              legacy_cipher().

Cipher algorithms that can be used for payload encryption.

Link to this type

# cipher_filters()

View Source

    -type cipher_filters() ::
              [{key_exchange | cipher | mac | prf,
                fun((kex_algo() | cipher() | hash() | aead | default_prf) -> true | false)}].

Filter that allows you to customize cipher suite list.

Link to this type

# cipher_suites()

View Source (not exported)

    -type cipher_suites() :: ciphers().

A list of cipher suites that should be supported

The function ssl:cipher_suites/2 can be used to find all cipher suites that are supported by default and all cipher suites that may be configured.

If you compose your own `cipher_suites/0` make sure they are filtered for cryptolib support ssl:filter_cipher_suites/2 Additionally the functions ssl:append_cipher_suites/2 , ssl:prepend_cipher_suites/2, ssl:suite_to_str/1, ssl:str_to_suite/1, and ssl:suite_to_openssl_str/1 also exist to help creating customized cipher suite lists.

> #### Note

> Note that TLS-1.3 and TLS-1.2 cipher suites are not overlapping sets of cipher suites. To support both these versions cipher suites from both versions need to be included. Also if the supplied list does not comply with the configured versions or cryptolib so that the list becomes empty, this option will fallback on its appropriate default value for the configured versions.

Non-default cipher suites including anonymous cipher suites (PRE TLS-1.3) are supported for interop/testing purposes and may be used by adding them to your cipher suite list. Note that they must also be supported/enabled by the peer to actually be used. The may also requier additional configuration see `srp_param_type/0`.

Link to this type

# ciphers()

View Source

    -type ciphers() :: [erl_cipher_suite()] | string().

Cipher suite formats.

For backwards compatibility cipher suites can configured as a : separated string of cipher suite RFC names (or even old OpenSSL names) althogh the more flexible way is to use uitility functions together with `cipher_filters/0` if a customized cipher suite option is needed.

Link to this type

# erl_cipher_suite()

View Source

    -type erl_cipher_suite() ::
              #{key_exchange := kex_algo(),
                cipher := cipher(),
                mac := hash() | aead,
                prf := hash() | default_prf}.

Erlang cipher suite representation

> #### Warning

> Enabling cipher suites using RSA as a key exchange algorithm is strongly discouraged (only available pre TLS-1.3). For some configurations software preventions may exist, and can make them usable if they work, but relying on them to work is risky and there are many more reliable cipher suites that can be used instead.

Link to this type

# group()

View Source

    -type group() ::
              x25519 | x448 | secp256r1 | secp384r1 | secp521r1 | ffdhe2048 | ffdhe3072 | ffdhe4096 |
              ffdhe6144 | ffdhe8192.

TLS-1.3 key exchange configuration.

Link to this type

# hash()

View Source

    -type hash() :: sha2() | legacy_hash().

Hash algorithms used together with signing and encryption functions.

Link to this type

# kex_algo()

View Source

    -type kex_algo() ::
              ecdhe_ecdsa | ecdh_ecdsa | ecdh_rsa | rsa | dhe_rsa | dhe_dss | srp_rsa | srp_dss | dhe_psk |
              rsa_psk | psk | ecdh_anon | dh_anon | srp_anon | any.

Cipher Suite Key Exchange Algorithm will be any in TLS-1.3 as key exchange is no longer part of cipher suite configuration in TLS-1.3.

Link to this type

# named_curve()

View Source

    -type named_curve() ::
              x25519 | x448 | secp521r1 | brainpoolP512r1 | brainpoolP384r1 | secp384r1 | brainpoolP256r1 |
              secp256r1 |
              legacy_named_curve().

Pre TLS-1.3 key exchange configuration.

Link to this type

# rsassa_pss_scheme()

View Source (not exported)

    -type rsassa_pss_scheme() ::
              rsa_pss_rsae_sha512 | rsa_pss_rsae_sha384 | rsa_pss_rsae_sha256 | rsa_pss_pss_sha512 |
              rsa_pss_pss_sha384 | rsa_pss_pss_sha256.

Supported in TLS-1.3 and TLS-1.2.

Link to this type

# sha2()

View Source (not exported)

    -type sha2() :: sha512 | sha384 | sha256.

SHA2 hash algorithms.

Link to this type

# sign_algo()

View Source

    -type sign_algo() :: eddsa | ecdsa | rsa | legacy_sign_algo().

Signature algorithms.

Link to this type

# sign_scheme()

View Source

    -type sign_scheme() ::
              eddsa_ed25519 | eddsa_ed448 | ecdsa_secp521r1_sha512 | ecdsa_secp384r1_sha384 |
              ecdsa_secp256r1_sha256 | ecdsa_brainpoolP512r1tls13_sha512 |
              ecdsa_brainpoolP384r1tls13_sha384 | ecdsa_brainpoolP256r1tls13_sha256 |
              rsassa_pss_scheme() |
              legacy_sign_scheme().

Signature schemes, defined by TLS-1.3, and replaces signature algorithms from TLS-1.2.

Explicitly list acceptable signature schemes in the preferred order.

Overrides the algorithms supplied in `signature_algs` option for certificates. In addition to the `signature_algorithms` extension from TLS 1.2, TLS 1.3 (RFC 5246 Section 4.2.3) adds the `signature_algorithms_cert` extension which enables having special requirements on the signatures used in the certificates that differs from the requirements on digital signatures as a whole. If this is not required this extension is not need.

The client will send a `signature_algorithms_cert` extension (in the client hello message), if TLS version 1.2 (back-ported to TLS 1.2 in 24.1) or later is used, and the signature_algs_cert option is explicitly specified. By default, only the signature_algs extension is sent with the exception of when signature_algs option is not explicitly specified, in which case it will append the rsa_pkcs1_sha1 algorithm to the default value of signature_algs and use it as value for signature_algs_cert to allow certificates to have this signature but still disallow sha1 use in the TLS protocol, since 27.0.1 and 26.2.5.2.

> #### Note

> Note that supported signature schemes for TLS-1.2 are `legacy_sign_scheme/0` and `rsassa_pss_scheme/0`

Link to this type

# signature_algs()

View Source

    -type signature_algs() :: [{hash(), sign_algo()} | sign_scheme()].

Explicitly list acceptable signature algorithms for certificates and handshake messages in the preferred order.

The client will send its list as the client hello `signature_algorithm` extension introduced in TLS-1.2, see Section 7.4.1.4.1 in RFC 5246. Previously these algorithms where implicitly chosen and partly derived from the cipher suite.

In TLS-1.2 a somewhat more explicit negotiation is made possible using a list of {`hash/0`, `sign_algo/0`} pairs.

In TLS-1.3 these algorithm pairs are replaced by so called signature schemes `sign_scheme/0` and completely decoupled from the cipher suite.

Signature algorithms used for certificates may be overridden by the [signature schemes] supplied by the `signature_algs_cert` option.

TLS-1.2 default is Default_TLS_12_Alg_Pairs interleaved with rsa_pss_schemes since ssl-11.0 (OTP 25) pss_pss is prefered over pss_rsae that is prefered over rsa

`Default_TLS_12_Alg_Pairs =`

    [
    %% SHA2
    {sha512, ecdsa},
    {sha512, rsa},
    {sha384, ecdsa},
    {sha384, rsa},
    {sha256, ecdsa},
    {sha256, rsa}
    ]

Support for {md5, rsa} was removed from the the TLS-1.2 default in ssl-8.0 (OTP 22) and support for SHA1 {sha, } and SHA224 {sha224, } was removed in ssl-11.0 (OTP 26)

`rsa_pss_schemes =`

    [rsa_pss_pss_sha512,
    rsa_pss_pss_sha384,
    rsa_pss_pss_sha256,
    rsa_pss_rsae_sha512,
    rsa_pss_rsae_sha384,
    rsa_pss_rsae_sha256]

`TLS_13_Legacy_Schemes =`

     [
     %% Legacy algorithms only applicable to certificate signatures
    rsa_pkcs1_sha512, %% Corresponds to {sha512, rsa}
    rsa_pkcs1_sha384, %% Corresponds to {sha384, rsa}
    rsa_pkcs1_sha256, %% Corresponds to {sha256, rsa}
    ]

`Default_TLS_13_Schemes =`

     [
     %% EDDSA
    eddsa_ed25519,
    eddsa_ed448

    %% ECDSA
    ecdsa_secp521r1_sha512,
    ecdsa_secp384r1_sha384,
    ecdsa_secp256r1_sha256] ++

    %% RSASSA-PSS
    rsa_pss_schemes()

EDDSA was made highest priority in ssl-10.8 (OTP 25)

TLS-1.3 default is

    Default_TLS_13_Schemes

If both TLS-1.3 and TLS-1.2 are supported the default will be

    Default_TLS_13_Schemes ++ TLS_13_Legacy_Schemes ++
    Default_TLS_12_Alg_Pairs (not represented in TLS_13_Legacy_Schemes)

so appropriate algorithms can be chosen for the negotiated version.

> #### Note

> TLS-1.2 algorithms will not be negotiated for TLS-1.3, but TLS-1.3 RSASSA-PSS `rsassa_pss_scheme/0` signature schemes may be negotiated also for TLS-1.2 from 24.1 (fully working from 24.1.3). However if TLS-1.3 is negotiated when both TLS-1.3 and TLS-1.2 is supported using defaults, the corresponding TLS-1.2 algorithms to the TLS-1.3 legacy signature schemes will be considered as the legacy schemes and applied only to certificate signatures.

Link to this type

# srp_param_type()

View Source

    -type srp_param_type() :: srp_8192 | srp_6144 | srp_4096 | srp_3072 | srp_2048 | srp_1536 | srp_1024.

Pre TLS-1.3 SRP cipher suite configuration.

# Types: Certificates

Link to this type

# anchor_fun()

View Source (not exported)

    -type anchor_fun() :: fun().

Claim an intermediate CA in the chain as trusted.

      fun(Chain::[public_key:der_encoded()]) ->
        {trusted_ca, DerCert::public_key:der_encoded()} | unknown_ca.

TLS then performs `public_key:pkix_path_validation/3` with the selected CA as trusted anchor and the rest of the chain.

Link to this type

# cert_key_conf()

View Source

    -type cert_key_conf() ::
              #{cert => public_key:der_encoded() | [public_key:der_encoded()],
                key => key(),
                certfile => file:filename(),
                keyfile => file:filename(),
                password => iodata() | fun(() -> iodata())}.

Configuration of the entity certificate and its corresponding key.

A certificate (or possibly a list of the certificate and its chain certificates where the entity certificate must be the first element in the list or first entry in the file) and its associated key on one of the possible formats. For the PEM file format there may also be a password associated with the file containg the key.

For maximum interoperability the certificates in the chain should be in the correct order, the chain will be sent as is to the peer. If chain certificates are not provided, certificates from the configured trusted CA-certs are used to construct the chain. See certificate options for the client and server

Link to this type

# crl_cache_opts()

View Source (not exported)

    -type crl_cache_opts() :: {Module :: atom(), {DbHandle :: internal | term(), Args :: list()}}.

Options for using built in CRL cache support.

Specify how to perform lookup and caching of certificate revocation lists. `Module` defaults to `ssl_crl_cache` with `DbHandle`being `internal` and an empty argument list.

There are two implementations available:

- `ssl_crl_cache` - Implementation 1

  This module maintains a cache of CRLs. CRLs can be added to the cache using the function `ssl_crl_cache:insert/1`, and optionally automatically fetched through HTTP if the following argument is specified:

- `{http, timeout()}`

  Enables fetching of CRLs specified as http URIs inX509 certificate extensions. Requires the OTP inets application.

- `ssl_crl_hash_dir` - Implementation 2

  This module makes use of a directory where CRLs are stored in files named by the hash of the issuer name.

  The file names consist of eight hexadecimal digits followed by `.rN`, where `N` is an integer, e.g. `1a2b3c4d.r0`. For the first version of the CRL, `N` starts at zero, and for each new version, `N` is incremented by one. The OpenSSL utility `c_rehash` creates symlinks according to this pattern.

  For a given hash value, this module finds all consecutive `.r*` files starting from zero, and those files taken together make up the revocation list. CRL files whose `nextUpdate` fields are in the past, or that are issued by a different CA that happens to have the same name hash, are excluded.

  The following argument is required:

  - `{dir, string()}`

Specifies the directory in which the CRLs can be found.

Link to this type

# key()

View Source

    -type key() ::
              {'RSAPrivateKey' | 'DSAPrivateKey' | 'ECPrivateKey' | 'PrivateKeyInfo',
               public_key:der_encoded()} |
              #{algorithm := sign_algo(),
                engine := crypto:engine_ref(),
                key_id := crypto:key_id(),
                password => crypto:password()} |
              #{algorithm := sign_algo(),
                sign_fun := fun(),
                sign_opts => list(),
                encrypt_fun => fun(),
                encrypt_opts => list()}.

The user's private key.

Either the key can be provided directly as DER encoded entity, or indirectly using a crypto engine/provider (with key reference information) or an Erlang fun (with possible custom options). The latter two options can both be used for customized signing with for instance hardware security modules (HSM) or trusted platform modules (TPM).

- A DER encoded key will need to specify the ASN-1 type used to create the encoding.
- An engine/provider needs to specify specific information to support this concept and can optionally be password protected, see also crypto:engine_load/3 and Crypto's Users Guide.
- A fun option should include a fun that mimics `public_key:sign/4` and possibly public_key:private_encrypt/4 if legacy versions TLS-1.0 and TLS-1.1 should be supported.

# Types: Algorithms Legacy

Link to this type

# legacy_cipher()

View Source (not exported)

    -type legacy_cipher() :: '3des_ede_cbc' | des_cbc | rc4_128.

Cipher algorithms that for security reason no longer are supported by default.

Link to this type

# legacy_hash()

View Source (not exported)

    -type legacy_hash() :: sha224 | sha | md5.

Hash algorithms that for security reason no longer are supported by default

Link to this type

# legacy_named_curve()

View Source (not exported)

    -type legacy_named_curve() ::
              sect571r1 | sect571k1 | sect409k1 | sect409r1 | sect283k1 | sect283r1 | secp256k1 |
              sect239k1 | sect233k1 | sect233r1 | secp224k1 | secp224r1 | sect193r1 | sect193r2 |
              secp192k1 | secp192r1 | sect163k1 | sect163r1 | sect163r2 | secp160k1 | secp160r1 | secp160r2.

Pre TLS-1.3 key exchange configuration. These curves has been deprecated by RFC 8422.

Link to this type

# legacy_sign_algo()

View Source (not exported)

    -type legacy_sign_algo() :: dsa.

Signature algorithms that for security reasons no longer are supported by default

Link to this type

# legacy_sign_scheme()

View Source (not exported)

    -type legacy_sign_scheme() ::
              rsa_pkcs1_sha512 | rsa_pkcs1_sha384 | rsa_pkcs1_sha256 | ecdsa_sha1 | rsa_pkcs1_sha1.

Only used for certificate signatures if TLS-1.2 is negotiated, that is the peer only supports TLS-1.2 but we support also TLS-1.3.

Link to this type

# old_cipher_suite()

View Source

    -type old_cipher_suite() ::
              {kex_algo(), cipher(), hash()} | {kex_algo(), cipher(), hash() | aead, hash()}.

For backwards compatibility only, do not use it.

# Types: Client Options

Link to this type

# client_option()

View Source (not exported)

    -type client_option() ::
              client_option_cert() |
              common_option_cert() |
              {alpn_advertised_protocols, AppProtocols :: [AppProto :: binary()]} |
              {max_fragment_length, MaxLen :: undefined | 512 | 1024 | 2048 | 4096} |
              client_option_tls13() |
              common_option_tls13() |
              client_option_pre_tls13() |
              common_option_pre_tls13() |
              common_option_dtls() |
              client_option_legacy() |
              common_option_legacy().

Options specific to the client side, or with different semantics for the client and server.

- {alpn_advertised_protocols, AppProtocols} - Application layer protocol

  The list of protocols supported by the client to be sent to the server to be used for an Application-Layer Protocol Negotiation (ALPN). If the server supports ALPN then it will choose a protocol from this list; otherwise it will fail the connection with a 'no_application_protocol' alert. A server that does not support ALPN will ignore this value.The list of protocols must not contain an empty binary.

- {max_fragment_length, MaxLen} - Max fragment length extension

  Specifies the maximum fragment length the client is prepared to accept from the server. See RFC 6066

Link to this type

# client_option_cert()

View Source

    -type client_option_cert() ::
              {verify, Verify :: verify_peer | verify_none} |
              {cacerts, CACerts :: [public_key:der_encoded()] | [public_key:combined_cert()]} |
              {cacertfile, CACertFile :: file:filename()} |
              {server_name_indication, SNI :: inet:hostname() | disabled} |
              {customize_hostname_check, HostNameCheckOpts :: list()} |
              {certificate_authorities, boolean()} |
              {stapling, Stapling :: staple | no_staple | map()}.

Certificate related options specific to the client side, or with different semantics for the client and server.

- {verify, Verify} - Verification of certificates

  Defaults to `verify_peer`, since OTP 26, which means the option cacerts or cacertfile is also required to perform the certificate verification unless `verify_none` is explicitly configured. For example an `HTTPS` client would normally use the option `{cacerts, public_key:cacerts_get()}` (available since OTP 25) to access the CA certificates provided by the OS. Using verify_none means that all x509-certificate path validation errors will be ignored.

- {cacerts, CACerts} - Trusted certificates

  The DER-encoded trusted certificates. If this option is supplied it overrides option `cacertfile`.

- {cacertfile, CertFile} - End entity certificate

  Path to a file containing PEM-encoded CA certificates. The CA certificates are used during server authentication and when building the client certificate chain.

  > #### Note

  > When PEM caching is enabled, files provided with this option will be checked for updates at fixed time intervals specified by the ssl_pem_cache_clean environment parameter.

- {server_name_indication, SNI} - Server Name Indication extension

  Specify the hostname to be used in TLS Server Name Indication extension. If not specified it will default to the `Host` argument of connect/3,4 unless it is of type inet:ipaddress(). The `HostName` will also be used in the hostname verification of the peer certificate using `public_key:pkix_verify_hostname/2`. The special value `disable` prevents the Server Name Indication extension from being sent and disables the hostname verification check `public_key:pkix_verify_hostname/2`

- {customize_hostname_check, HostNameCheckOpts} - Customization option

  Customizes the hostname verification of the peer certificate, as different protocols that use TLS such as HTTP or LDAP may want to do it differently. For example the get standard HTTPS handling provide the already implememnted fun from the public_key application for HTTPS. `{customize_hostname_check, [{match_fun, public_key:pkix_verify_hostname_match_fun(https)}]}` For futher description of customize options see `public_key:pkix_verify_hostname/3`

- {client_certificate_authorities, UseCertAuth} -Inter-op hint option

  If set to true, sends the certificate authorities extension in TLS-1.3 client hello. The default is false. Note that setting it to true may result in a big overhead if you have many trusted CA certificates. Since OTP 24.3.

- {stapling, Stapling} - Certificate revocation check option

  If `staple` or a map, OCSP stapling will be enabled, an extension of type "status_request" will be included in the client hello to indicate the desire to receive certificate status information. If `no_staple` (the default), OCSP stapling will be disabled.

> #### Note

> Even if requested by the client, OCSP response might not be provided by the server. In such event, ssl will proceed with handshake and generate notice {missing, stapling_response} logger event.

When map is used, boolean ocsp_nonce key may indicate if OCSP nonce should be requested by the client (default is `false`).

> #### Note

> OCSP response can be provided without a nonce value - even if it was requested by the client. In such cases ssl will proceed with handshake and generate info {missing, ocsp_nonce} logger event.

Link to this type

# client_option_legacy()

View Source (not exported)

    -type client_option_legacy() ::
              {client_preferred_next_protocols,
               NextAppProtocols ::
                   {Precedence :: server | client, ClientPrefs :: [AppProto :: binary()]} |
                   {Precedence :: server | client,
                    ClientPrefs :: [AppProto :: binary()],
                    Default :: (AppProto :: binary())}}.

Legacy client options.

- {client_preferred_next_protocols, NextAppProtocols} - Next Protocol Negotiation

  ALPN (Application-Layer Protocol Negotiation) deprecats NPN (Next Protocol Negotiation) described here.

  Indicates that the client wants to perform Next Protocol Negotiation.

  If precedence is server, the negotiated protocol is the first protocol to be shown on the server advertised list, which is also on the client preference list.

  If precedence is client, the negotiated protocol is the first protocol to be shown on the client preference list, which is also on the server advertised list.

  If the client does not support any of the server advertised protocols or the server does not advertise any protocols, the client falls back to the first protocol in its list or to the default protocol (if a default is supplied). If the server does not support Next Protocol Negotiation, the connection terminates if no default protocol is supplied.

Link to this type

# client_option_pre_tls13()

View Source (not exported)

    -type client_option_pre_tls13() ::
              {reuse_session, SessionRef :: session_id() | {session_id(), SessionData :: binary()}} |
              {reuse_sessions, Reuse :: boolean() | save} |
              {psk_identity, PskID :: string()} |
              {srp_identity, SrpID :: {Username :: string(), Password :: string()}} |
              {fallback, LegacyFallback :: boolean()}.

Options only relevant to TLS versions pre TLS-1.3.

- {reuse_session, SessionRef} - Explicitly session reuse

  Reuses a specific session. The session should be referred by its session id if it is earlier saved with the option `{reuse_sessions, save}` since OTP 21.3 or explicitly specified by its session id and associated data since OTP 22.3. See also SSL's Users Guide, Session Reuse pre TLS 1.3.

- {reuse_sessions, Reuse} - Enables later session reuse

  When `save` is specified a new connection will be negotiated and saved for later reuse. The session ID can be fetched with `connection_information/2` and used with the client option `reuse_session` The boolean value true specifies that if possible, automated session reuse will be performed. If a new session is created, and is unique in regard to previous stored sessions, it will be saved for possible later reuse. Since OTP 21.3.

- {psk_identity, PskID} - Option for use with PSK cipher suites

  Specifies the identity the client presents to the server. The matching secret is found by calling `user_lookup_fun`

- {srp_identity, SrpID} - Option for use SRP cipher suites

  Specifies the username and password to use to authenticate to the server.

- {fallback, LegacyFallback} - Inter-op legacy client option

  Send special cipher suite TLS_FALLBACK_SCSV to avoid undesired TLS version downgrade. Defaults to false

  > #### Warning

  > Note this option is not needed in normal TLS usage and should not be used to implement new clients. But legacy clients that retries connections in the following manner

  > `ssl:connect(Host, Port, [...{versions, ['tlsv2', 'tlsv1.1', 'tlsv1']}])`

  > `ssl:connect(Host, Port, [...{versions, [tlsv1.1', 'tlsv1']}, {fallback, true}])`

  > `ssl:connect(Host, Port, [...{versions, ['tlsv1']}, {fallback, true}])`

  > may use it to avoid undesired TLS version downgrade. Note that TLS_FALLBACK_SCSV must also be supported by the server for the prevention to work.

Link to this type

# client_option_tls13()

View Source (not exported)

    -type client_option_tls13() ::
              {session_tickets, SessionTickets :: disabled | manual | auto} |
              {use_ticket, Tickets :: [binary()]} |
              {early_data, binary()} |
              {middlebox_comp_mode, MiddleBoxMode :: boolean()}.

Options only relevant for TLS-1.3.

- {session_tickets, SessionTickets}

  Configures the session ticket functionality. Allowed values are `disabled`, `stateful`, `stateless`, `stateful_with_cert`, `stateless_with_cert`.

  If it is not set to `disabled`, session resumption with pre-shared keys is enabled and the server will send stateful or stateless session tickets to the client after successful connections.

  > #### Note

  > Pre-shared key session ticket resumption does not include any certificate exchange, hence the function ssl:peercert/1 will not be able to return the peer certificate as it is only communicated in the initial handshake. The server options `stateful_with_cert` or `stateless_with_cert` may be used to make a server associate the client certificate from the original handshake with the tickets it issues.

  A stateful session ticket is a database reference to internal state information. A stateless session ticket is a self-encrypted binary that contains both cryptographic keying material and state data.

  > #### Warning

  > If it is set to `stateful_with_cert` the client certificate is stored with the internal state information, increasing memory consumption. If it is set to `stateless_with_cert` the client certificate is encoded in the self-encrypted binary that is sent to the client, increasing the payload size.

  See also SSL's Users Guide, Session Tickets and Session Resumption in TLS 1.3

- {use_ticket, Tickets}

  Configures the session tickets to be used for session resumption. It is a mandatory option in `manual` mode (`session_tickets = manual`).

  > #### Note

  > Session tickets are only sent to user if option session_tickets is set to `manual`

  > This option is supported by TLS 1.3. See also SSL's Users Guide, Session Tickets and Session Resumption in TLS 1.3

- {early_data, EarlyData}

  Configures the early data to be sent by the client.

  In order to be able to verify that the server has the intention to process the early data, the following 3-tuple is sent to the user process:

  `{ssl, SslSocket, {early_data, Result}}`

  where `Result` is either `accepted` or `rejected`.

  > #### Warning

  > It is the responsibility of the user to handle a rejected Early Data and to resend when it is appropriate.

- {middlebox_comp_mode, MiddleBoxMode}

  Configures the middlebox compatibility mode on a TLS 1.3 connection.

  A significant number of middleboxes misbehave when a TLS 1.3 connection is negotiated. Implementations can increase the chance of making connections through those middleboxes by making the TLS 1.3 handshake more like a TLS 1.2 handshake.

  The middlebox compatibility mode is enabled (`true`) by default.

# Types: Server Options

Link to this type

# server_option()

View Source (not exported)

    -type server_option() ::
              server_option_cert() |
              common_option_cert() |
              {alpn_preferred_protocols, AppProtocols :: [binary()]} |
              {sni_hosts, SNIHosts :: [{inet:hostname(), [server_option() | common_option()]}]} |
              {sni_fun, SNIFun :: fun((string()) -> [])} |
              server_option_pre_tls13() |
              common_option_pre_tls13() |
              server_option_tls13() |
              common_option_tls13() |
              common_option_dtls() |
              server_option_legacy() |
              common_option_legacy().

Options specific to the server side, or with different semantics for the client and server.

- {alpn_preferred_protocols, AppProtocols} - Application Layer Protocol Negotiation

  Indicates the server will try to perform Application-Layer Protocol Negotiation (ALPN).

  The list of protocols is in order of preference. The protocol negotiated will be the first in the list that matches one of the protocols advertised by the client. If no protocol matches, the server will fail the connection with a "no_application_protocol" alert.

  The negotiated protocol can be retrieved using the `negotiated_protocol/1` function.

- {sni_hosts, SNIHosts}

  If the server receives a SNI (Server Name Indication) from the client, the given function will be called to retrieve [[server_option()] ](`server_option/0`)for the indicated server. These options will be merged into predefined [[server_option()] ](`server_option/0`)list. The function should be defined as: fun(ServerName :: string()) -> [[server_option()] ](`server_option/0`)and can be specified as a fun or as named `fun module:function/1` The option `sni_fun`, and `sni_hosts` are mutually exclusive.

- {sni_hosts, SNIFun}

  If the server receives a SNI (Server Name Indication) from the client matching a host listed in the `sni_hosts` option, the specific options for that host will override previously specified options. The option `sni_fun`, and `sni_hosts` are mutually exclusive.

Link to this type

# server_option_cert()

View Source

    -type server_option_cert() ::
              {cacerts, CACerts :: [public_key:der_encoded()] | [public_key:combined_cert()]} |
              {cacertfile, CACertFile :: file:filename()} |
              {verify, Verify :: verify_none | verify_peer} |
              {fail_if_no_peer_cert, FailNoPeerCert :: boolean()} |
              {certificate_authorities, ServerCertAuth :: boolean()}.

Certificate related options.

- {cacerts, CACerts} - Trusted certificates.

  The DER-encoded trusted certificates. If this option is supplied it overrides option `cacertfile`.

- {verify, Verify} - Verify certificates.

  Client certificates are an optional part of the TLS protocol. A server only does x509-certificate path validation in mode `verify_peer`. By default the server is in `verify_none` mode an hence will not send an certificate request to the client. When using `verify_peer` you may also want to specify the options fail_if_no_peer_cert and certificate_authorities.

- {fail_if_no_peer_cert, FailNoPeerCert} - Legacy tradeoff option

  Used together with `{verify, verify_peer}` by an TLS/DTLS server. If set to `true`, the server fails if the client does not have a certificate to send, that is, sends an empty certificate. If set to `false`, it fails only if the client sends an invalid certificate (an empty certificate is considered valid). Defaults to false.

- {certificate_authorities, ServerCertAuth} - Inter-operate hint option

  Determines if a TLS-1.3 server should include the authorities extension in its certificate request message that will be sent if the option `verify` is set to `verify_peer`. Defaults to `true`.

  A reason to exclude the extension would be if the server wants to communicate with clients incapable of sending complete certificate chains that adhere to the extension, but the server still has the capability to recreate a chain that it can verify.

Link to this type

# server_option_legacy()

View Source (not exported)

    -type server_option_legacy() :: {next_protocols_advertised, NextAppProtocols :: [binary()]}.

Legacy server options.

- {next_protocols_advertised, NextAppProtocols}

  ALPN (Application-Layer Protocol Negotiation) deprecats NPN (Next Protocol Negotiation) described here.

  List of protocols to send to the client if the client indicates that it supports the Next Protocol extension. The client can select a protocol that is not on this list. The list of protocols must not contain an empty binary. If the server negotiates a Next Protocol, it can be accessed using the `negotiated_next_protocol/1` method.

Link to this type

# server_option_pre_tls13()

View Source (not exported)

    -type server_option_pre_tls13() ::
              {client_renegotiation, ClientRengotiation :: boolean()} |
              {reuse_sessions, ReuseSessions :: boolean()} |
              {reuse_session, ReuseSession :: fun()} |
              {honor_cipher_order, HonorServerCipherOrder :: boolean()} |
              {honor_ecc_order, HonorServerECCOrder :: boolean()} |
              {dh, DHDer :: public_key:der_encoded()} |
              {dhfile, DhFile :: file:filename()} |
              {psk_identity, PSKHint :: string()}.

Options only relevant to TLS versions pre TLS-1.3.

- {client_renegotiation, ClientRengotiation} - DoS attack avoidance option

  In protocols that support client-initiated renegotiation, the cost of resources of such an operation is higher for the server than the client. This can act as a vector for denial of service attacks. The SSL application already takes measures to counter-act such attempts, but client-initiated renegotiation can be strictly disabled by setting this option to `false`. The default value is `true`. Note that disabling renegotiation can result in long-lived connections becoming unusable due to limits on the number of messages the underlying cipher suite can encipher.

- {reuse_sessions, ReuseSessions} - Enable session reuse

  The boolean value true specifies that the server will agree to reuse sessions. Setting it to false will result in an empty session table, that is no sessions will be reused.

- {reuse_session, ReuseSession} - Local server reuse policy

  Enables the TLS/DTLS server to have a local policy for deciding if a session is to be reused or not. Meaningful only if `reuse_sessions` is set to `true`. `SuggestedSessionId` is a `binary/0`, `PeerCert` is a DER-encoded certificate, `Compression` is an enumeration integer, and `CipherSuite` is of type `ciphersuite()`.

- {psk_identity, PSKHint} - Inter-operate hint option

  Specifies the server identity hint, which the server presents to the client.

- {honor_cipher_order, HonorServerCipherOrder} - Tradeoff option alters protocol defined behaviour

  If true, use the server's preference for ECC curve selection. If false (the default), use the client's preference.

- {honor_ecc_order, HonorServerECCOrder} - - Tradeoff option alters protocol defined behaviour

  If true, use the server's preference for ECC curve selection. If false (the default), use the client's preference.

- {dh, DHder} - Affects DH key exchange cipher suites

  The DER-encoded Diffie-Hellman parameters. If specified, it overrides option `dhfile`.

- {dh_file, DHfile} - Affects DH key exchange cipher suites

  Path to a file containing PEM-encoded Diffie Hellman parameters to be used by the server if a cipher suite using Diffie Hellman key exchange is negotiated. If not specified, default parameters are used.

Link to this type

# server_option_tls13()

View Source (not exported)

    -type server_option_tls13() ::
              {session_tickets,
               SessionTickets :: disabled | stateful | stateless | stateful_with_cert | stateless_with_cert} |
              {stateless_tickets_seed, TicketSeed :: binary()} |
              {anti_replay,
               '10k' | '100k' |
               {BloomFilterWindowSize :: pos_integer(),
                BloomFilterHashFunctions :: pos_integer(),
                BloomFilterBits :: pos_integer()}} |
              {cookie, Cookie :: boolean()} |
              {early_data, EarlyData :: enabled | disabled}.

Options only relevant for TLS-1.3.

- {session_tickets, SessionTickets} - Use of session tickets

  Configures the session ticket functionality. Allowed values are `disabled`, `manual` and `auto`. If it is set to `manual` the client will send the ticket information to user process in a 3-tuple:

  `{ssl, session_ticket, {SNI, TicketData}}`

  where `SNI` is the ServerNameIndication and `TicketData` is the extended ticket data that can be used in subsequent session resumptions.

  If it is set to `auto`, the client automatically handles received tickets and tries to use them when making new TLS connections (session resumption with pre-shared keys).

  Ticket lifetime, the number of tickets sent by the server and the maximum number of tickets stored by the server in stateful mode are configured by application variables.

  See also SSL's Users Guide, Session Tickets and Session Resumption in TLS 1.3

- {stateless_tickets_seed, TicketSeed} - Option for statless tickets

  Configures the seed used for the encryption of stateless session tickets. Allowed values are any randomly generated `binary/0`. If this option is not configured, an encryption seed will be randomly generated.

  > #### Warning

  > Reusing the ticket encryption seed between multiple server instances enables stateless session tickets to work across multiple server instances, but it breaks anti-replay protection across instances.

  > Inaccurate time synchronization between server instances can also affect session ticket freshness checks, potentially causing false negatives as well as false positives.

- {anti_replay, AntiReplay} - Option for statless tickets

  Configures the server's built-in anti replay feature based on Bloom filters.

  Allowed values are the pre-defined `'10k'`, `'100k'` or a custom 3-tuple that defines the properties of the bloom filters: `{WindowSize, HashFunctions, Bits}`. `WindowSize` is the number of seconds after the current Bloom filter is rotated and also the window size used for freshness checks of ClientHello. `HashFunctions` is the number hash functions and `Bits` is the number of bits in the bit vector. `'10k'` and `'100k'` are simple defaults with the following properties:

  - `'10k'`: Bloom filters can hold 10000 elements with 3% probability of false positives. `WindowSize`: 10, `HashFunctions`: 5, `Bits:` 72985 (8.91 KiB).
  - `'100k'`: Bloom filters can hold 100000 elements with 3% probability of false positives. `WindowSize`: 10, `HashFunctions`: 5, `Bits`: 729845 (89.09 KiB).

  See also SSL's Users Guide, Anti-Replay Protection in TLS 1.3

- {cookie, Cookie} - Option for `HelloRetyrRequest` behaviour

  If `true` (default), the server sends a cookie extension in its HelloRetryRequest messages.

  The cookie extension has two main purposes. It allows the server to force the client to demonstrate reachability at their apparent network address (thus providing a measure of DoS protection). This is primarily useful for non-connection-oriented transports. It also allows to offload the server's state to the client. The cookie extension is enabled by default as it is a mandatory extension in RFC8446.

- {early_data, EarlyData} - Option for accepting or rejecting Early Data

  Configures if the server accepts (`enabled`) or rejects (`rejects`) early data sent by a client. The default value is `disabled`.

# Types: Client and Server Options

Link to this type

# common_option()

View Source (not exported)

    -type common_option() ::
              {protocol, tls | dtls} |
              {handshake, hello | full} |
              {ciphers, cipher_suites()} |
              {signature_algs, signature_algs()} |
              {signature_algs_cert, [sign_scheme()]} |
              {keep_secrets, KeepSecrets :: boolean()} |
              {max_handshake_size, HandshakeSize :: pos_integer()} |
              {versions, [protocol_version()]} |
              {log_level, Level :: logger:level() | none | all} |
              {hibernate_after, HibernateTimeout :: timeout()} |
              {receiver_spawn_opts, SpawnOpts :: [erlang:spawn_opt_option()]} |
              {sender_spawn_opts, SpawnOpts :: [erlang:spawn_opt_option()]}.

Options common to both client and server side.

- {protocol, Protocol} - Choose TLS or DTLS protocol for the transport layer security.

  Defaults to `tls`.

- {handshake_completion, Completion} - Possibly pause handshake at hello stage.

  Defaults to `full`. If hello is specified the handshake will pause after the hello message and give the user a possibility make decisions based on hello extensions before continuing or aborting the handshake by calling `handshake_continue/3` or `handshake_cancel/1`

- {keep_secrets, KeepSecrets} - Configures a TLS 1.3 connection for keylogging

  In order to retrieve keylog information on a TLS 1.3 connection, it must be configured in advance to keep the client_random and various handshake secrets.

  The keep_secrets functionality is disabled (`false`) by default.

  Added in OTP 23.2

- {handshake_size, HandshakeSize} - Limit the acceptable handshake packet size.

  Used to limit the size of valid TLS handshake packets to avoid DoS attacks.

  Integer (24 bits unsigned). Defaults to 256*1024.

- {hibernate_after, HibernateTimeout} - Hibernate inactive connection processes

  When an integer-value is specified, `TLS/DTLS-connection` goes into hibernation after the specified number of milliseconds of inactivity, thus reducing its memory footprint. When not specified the process never goes into hibernation.

- {log_level, Level} - Specifies the log level for a TLS/DTLS connection.

  Alerts are logged on `notice` level, which is the default level. The level `debug` triggers verbose logging of TLS/DTLS protocol messages. See also SSL Application

- {receiver|sender_spawn_opts, SpawnOpts} - Configure erlang spawn opts.

  Configures spawn options of TLS sender and receiver processes.

  Setting up garbage collection options can be helpful for trade-offs between CPU usage and Memory usage. See `erlang:spawn_opt/2`.

  For dist connections, default sender option is `[...{priority, max}]`, this priority option cannot be changed. For all connections, `...link` is added to receiver and cannot be changed.

Link to this type

# common_option_cert()

View Source (not exported)

    -type common_option_cert() ::
              {certs_keys, CertsKeys :: [cert_key_conf()]} |
              {depth, AllowedCertChainLen :: pos_integer()} |
              {verify_fun, Verify :: {Verifyfun :: fun(), InitialUserState :: any()}} |
              {cert_policy_opts,
               PolicyOpts ::
                   [{policy_set, [public_key:oid()]} |
                    {explicit_policy, boolean()} |
                    {inhibit_policy_mapping, boolean()} |
                    {inhibit_any_policy, boolean()}]} |
              {crl_check, Check :: boolean() | peer | best_effort} |
              {crl_cache, crl_cache_opts()} |
              {partial_chain, anchor_fun()}.

Common certificate related options to both client and server.

- {certs_keys, CertsKeys} - At least one certificate and key pair.

  A list of a certificate (or possible a certificate and its chain) and the associated key of the certificate, that may be used to authenticate the client or the server. The certificate key pair that is considered best and matches negotiated parameters for the connection will be selected. Different signature algorithms are prioritized in the order `eddsa, ecdsa, rsa_pss_pss, rsa and dsa`. If more than one key is supplied for the same signing algorithm (which is probably an unusual use case) they will prioritized by strength unless it is a so called `engine key` that will be favoured over other keys. As engine keys cannot be inspected, supplying more than one engine key will make no sense. This offers flexibility to for instance configure a newer certificate that is expected to be used in most cases and an older but acceptable certificate that will only be used to communicate with legacy systems. Note that there is a trade off between the induced overhead and the flexibility so alternatives should be chosen for good reasons. If the `certs_keys` option is specified it overrides all single certificate and key options. For examples see the Users Guide

  > #### Note

  > `eddsa` certificates are only supported by TLS-1.3 that does not support `dsa` certificates. `rsa_pss_pss` (RSA certificates using Probabilistic Signature Scheme) are supported in TLS-1.2 and TLS-1.3, but some TLS-1.2 implementations may not support `rsa_pss_pss`.

- {depth, AllowedCertChainLen} - Limits the accepted number of certificates in the certificate chain.

  certificate_revoked Maximum number of non-self-issued intermediate certificates that can follow the peer certificate in a valid certification path. So, if depth is 0 the PEER must be signed by the trusted ROOT-CA directly; if 1 the path can be PEER, CA, ROOT-CA; if 2 the path can be PEER, CA, CA, ROOT-CA, and so on. The default value is 10. Used to mitigate DoS attack possibilities.

- {verify_fun, Verify} - Customize certificate path validation

  The verification fun is to be defined as follows:

      fun(OtpCert :: #'OTPCertificate'{},
          Event, InitialUserState :: term()) ->
        {valid, UserState :: term()} |
        {fail, Reason :: term()} | {unknown, UserState :: term()}.

      fun(OtpCert :: #'OTPCertificate'{}, DerCert :: public_key:der_encoded(),
          Event, InitialUserState :: term()) ->
        {valid, UserState :: term()} |
        {fail, Reason :: term()} | {unknown, UserState :: term()}.

      Types:
            Event = {bad_cert, Reason :: atom() |
                    {revoked, atom()}} |
            {extension, #'Extension'{}} |
                    valid |
                    valid_peer

  The verification fun is called during the X509-path validation when an error or an extension unknown to the SSL application is encountered. It is also called when a certificate is considered valid by the path validation to allow access to each certificate in the path to the user application. It differentiates between the peer certificate and the CA certificates by using `valid_peer` or `valid` as `Event` argument to the verification fun. See the public_key User's Guide for definition of `#'OTPCertificate'{}` and `#'Extension'{}`.

  - If the verify callback fun returns `{fail, Reason}`, the verification process is immediately stopped, an alert is sent to the peer, and the TLS/DTLS handshake terminates.
  - If the verify callback fun returns `{valid, UserState}`, the verification process continues.
  - If the verify callback fun always returns `{valid, UserState}`, the TLS/DTLS handshake does not terminate regarding verification failures and the connection is established.
  - If called with an extension unknown to the user application, return value `{unknown, UserState}` is to be used.

  Note that if the fun returns `unknown` for an extension marked as critical, validation will fail.

  Default option `verify_fun` in `verify_peer mode`:

      {fun(_,{bad_cert, _} = Reason, _) ->
         {fail, Reason};
          (_,{extension, _}, UserState) ->
         {unknown, UserState};
          (_, valid, UserState) ->
         {valid, UserState};
          (_, valid_peer, UserState) ->
             {valid, UserState}
       end, []}

  Default option `verify_fun` in mode `verify_none`:

       {fun(_,{bad_cert, _}, UserState) ->
         {valid, UserState};
          (_,{extension, #'Extension'{critical = true}}, UserState) ->
         {valid, UserState};
          (_,{extension, _}, UserState) ->
         {unknown, UserState};
          (_, valid, UserState) ->
         {valid, UserState};
          (_, valid_peer, UserState) ->
             {valid, UserState}
       end, []}

  The possible path validation errors are given on form `{bad_cert, Reason}` where `Reason` is:

- `unknown_ca`

  No trusted CA was found in the trusted store. The trusted CA is normally a so called ROOT CA, which is a self-signed certificate. Trust can be claimed for an intermediate CA (trusted anchor does not have to be self-signed according to X-509) by using option `partial_chain`.

- `selfsigned_peer`

  The chain consisted only of one self-signed certificate.

- `PKIX X-509-path validation error`

For possible reasons, see `public_key:pkix_path_validation/3`

- {cert_policy_opts, PolicyOpts} - Handle certificate policies

  Configure X509 certificate policy handling for the certificate path validation process see public_key:pkix_path_validation/3 for further explanation.

- {cerl_check, Check} - Handle certificate revocation lists

  Perform CRL (Certificate Revocation List) verification (public_key:pkix_crls_validate/3) on all the certificates during the path validation (public_key:pkix_path_validation/3) of the certificate chain. Defaults to `false`.

- `peer`

  Check is only performed on the peer certificate.

- `best_effort`

  If certificate revocation status cannot be determined it will be accepted as valid.

  The CA certificates specified for the connection will be used to construct the certificate chain validating the CRLs.

  The CRLs will be fetched from a local or external cache. See `ssl_crl_cache_api`.

Link to this type

# common_option_dtls()

View Source (not exported)

    -type common_option_dtls() ::
              {use_srtp, UseSrtp :: #{protection_profiles := [binary()], mki => binary()}}.

Common options to client and server only valid for DTLS.

- {use_srtp, UseSrtp} - Configures the `use_srtp` DTLS hello extension.

  In order to negotiate the use of SRTP data protection, clients include an extension of type "use_srtp" in the DTLS extended client hello. This extension MUST only be used when the data being transported is RTP or RTCP.

  The value is a map with a mandatory `protection_profiles` and an optional `mki` parameters.

  `protection_profiles` configures the list of the client's acceptable SRTP Protection Profiles. Each profile is a 2-byte binary. Example: `#{protection_profiles => [<<0,2>>, <<0,5>>]}`

  `mki` configures the SRTP Master Key Identifier chosen by the client.

  The srtp_mki field contains the value of the SRTP MKI which is associated with the SRTP master keys derived from this handshake. Each SRTP session MUST have exactly one master key that is used to protect packets at any given time. The client MUST choose the MKI value so that it is distinct from the last MKI value that was used, and it SHOULD make these values unique for the duration of the TLS session.

  > #### Note

  > OTP does not handle SRTP, so an external implementations of SRTP encoder/decoder and a packet demultiplexer are needed to make use of the `use_srtp` extension. See also transport_option option.

  Servers that receive an extended hello containing a "use_srtp" extension can agree to use SRTP by including an extension of type "use_srtp", with the chosen protection profile in the extended server hello. This extension MUST only be used when the data being transported is RTP or RTCP.

Link to this type

# common_option_legacy()

View Source (not exported)

    -type common_option_legacy() ::
              {cert, Cert :: public_key:der_encoded() | [public_key:der_encoded()]} |
              {certfile, CertPem :: file:filename()} |
              {key, Key :: key()} |
              {keyfile, KeyPem :: file:filename()} |
              {password, KeyPemPasswd :: iodata() | fun(() -> iodata())} |
              {log_alert, LogAlert :: boolean()} |
              {padding_check, PaddingCheck :: boolean()} |
              {beast_mitigation, one_n_minus_one | zero_n | disabled} |
              {ssl_imp, Imp :: new | old}.

Legacy options considered deprecated in favour of other options, insecure to use, or plainly not relevant anymore.

- {cert, Certs}

  Use option certs_keys instead.

- {certfile, CertPem}

  Use option certs_keys instead.

- {keyfile, KeyPem}

  Use option certs_keys instead.

- {password, KeyPemPasswd}

  Use option certs_keys instead.

- {log_alert, LogAlert}

  If set to `false`, TLS/DTLS Alert reports are not displayed. Deprecated in OTP 22, use {log_level, Level} instead.

- {padding_check, PaddingCheck} - Inter-op tradeoff option

  Affects TLS-1.0 connections only. If set to `false`, it disables the block cipher padding check to be able to interoperate with legacy software.

  > #### Warning

  > Using `{padding_check, false}` makes TLS vulnerable to the Poodle attack.

- {beast_mitigation, BeastMitigation} - Inter-op tradeoff option

  Affects TLS-1.0 connections only. Used to change the BEAST mitigation strategy to interoperate with legacy software. Defaults to `one_n_minus_one`.

  `one_n_minus_one` - Perform 1/n-1 BEAST mitigation.

  `zero_n` - Perform 0/n BEAST mitigation.

  `disabled` - Disable BEAST mitigation.

  > #### Warning

  > Using `{beast_mitigation, disabled}` makes TLS-1.0 vulnerable to the BEAST attack.

- {ssl_imp, Imp}

  Deprecated since OTP 17, has no effect.

Link to this type

# common_option_pre_tls13()

View Source (not exported)

    -type common_option_pre_tls13() ::
              {eccs, NamedCurves :: [named_curve()]} |
              {secure_renegotiate, SecureRenegotiate :: boolean()} |
              {user_lookup_fun, {Lookupfun :: fun(), UserState :: any()}}.

Options common to both client and server side pre TLS-1.3.

- {eccs, NamedCurves} - Named Elliptic Curves

  Elliptic curves that can be use in pre TLS-1.3 key exchange.

- {secure_renegotiate, SecureRenegotiate} - Inter-operate tradeoff option

  Specifies if to reject renegotiation attempt that does not live up to RFC 5746. By default `secure_renegotiate` is set to `true`, that is, secure renegotiation is enforced. If set to `false` secure renegotiation will still be used if possible, but it falls back to insecure renegotiation if the peer does not support RFC 5746.

- {user_lookup_fun, {LookupFun, UserState}} - PSK/SRP cipher suite option

  The lookup fun is to defined as follows:

      fun(psk, PSKIdentity :: binary(), UserState :: term()) ->
        {ok, SharedSecret :: binary()} | error;
      fun(srp, Username :: binary(), UserState :: term()) ->
        {ok, {SRPParams :: srp_param_type(), Salt :: binary(),
              DerivedKey :: binary()}} | error.

  For Pre-Shared Key (PSK) cipher suites, the lookup fun is called by the client and server to determine the shared secret. When called by the client, `PSKIdentity` is set to the hint presented by the server or to undefined. When called by the server, `PSKIdentity` is the identity presented by the client.

  For Secure Remote Password (SRP), the fun is only used by the server to obtain parameters that it uses to generate its session keys. `DerivedKey` is to be derived according to RFC 2945 and RFC 5054: `crypto:sha([Salt, crypto:sha([Username, <<$:>>, Password])])`

Link to this type

# common_option_tls13()

View Source

    -type common_option_tls13() ::
              {supported_groups, [group()]} | {key_update_at, KeyUpdateAt :: pos_integer()}.

Common options to both client and server for TLS-1.3.

- {supported_groups, Groups} - Key exchange option

  TLS 1.3 introduces the "supported_groups" extension that is used for negotiating the Diffie-Hellman parameters in a TLS 1.3 handshake. Both client and server can specify a list of parameters that they are willing to use.

  If it is not specified it will use a default list ([x25519, x448, secp256r1, secp384r1]) that is filtered based on the installed crypto library version.

- {key_update_at, KeyUpdateAt} - Session key renewal

  Configures the maximum amount of bytes that can be sent on a TLS 1.3 connection before an automatic key update is performed.

  There are cryptographic limits on the amount of plaintext which can be safely encrypted under a given set of keys. The current default ensures that data integrity will not be breached with probability greater than 1/2^57. For more information see Limits on Authenticated Encryption Use in TLS.

  > #### Warning

  > The default value of this option shall provide the above mentioned security guarantees and it shall be reasonable for most applications (~353 TB).

# Types: Info

Link to this type

# connection_info()

View Source

    -type connection_info() ::
              [{protocol, protocol_version()} |
               {session_resumption, boolean()} |
               {selected_cipher_suite, erl_cipher_suite()} |
               {sni_hostname, term()} |
               {ciphers, [erl_cipher_suite()]}] |
              connection_info_pre_tls13() |
              security_info().

Key value list convening some information about the established connection.

Link to this type

# connection_info_keys()

View Source

    -type connection_info_keys() ::
              [protocol | selected_cipher_suite | sni_hostname | session_resumption | ciphers |
               client_random | server_random | master_secret | keylog | session_id | session_data | ecc |
               srp_username].

TLS connection keys that you can get information about.

Link to this type

# connection_info_pre_tls13()

View Source (not exported)

    -type connection_info_pre_tls13() ::
              [{session_id, session_id()} |
               {session_data, binary()} |
               {ecc, {named_curve, term()}} |
               {srp_username, term()}].

TLS connection information relevant pre TLS-1.3.

Link to this type

# security_info()

View Source (not exported)

    -type security_info() ::
              [{client_random, binary()} |
               {server_random, binary()} |
               {master_secret, binary()} |
               {keylog, term()}].

TLS connection information that can be used for NSS-keyloging.

# Types: Deprecated

Link to this type

# prf_random()

View Source
This type is deprecated. the type ssl:prf_random() is deprecated; Only used in deprecated function prf/5 and will no longer be needed..

    -type prf_random() :: client_random | server_random.

# Client API

Link to this function

# connect(TCPSocket, TLSOptions)

View Source (since OTP R14B)

    -spec connect(TCPSocket, TLSOptions) ->
                     {ok, sslsocket()} | {error, reason()} | {option_not_a_key_value_tuple, any()}
                     when TCPSocket :: socket(), TLSOptions :: [tls_client_option()].

Equivalent to `connect(TCPSocket, TLSOptions, infinity)`.

Link to this function

# connect(TCPSocketOrHost, TLSOptionsOrPort, TimeoutOrTLSOptions)

View Source

    -spec connect(TCPSocketOrHost, TLSOptionsOrPort, TimeoutOrTLSOptions) ->
                     {ok, sslsocket()} |
                     {ok, sslsocket(), Ext :: protocol_extensions()} |
                     {error, reason()} |
                     {option_not_a_key_value_tuple, any()}
                     when
                         TCPSocketOrHost :: socket() | host(),
                         TLSOptionsOrPort :: [tls_client_option()] | inet:port_number(),
                         TimeoutOrTLSOptions :: [tls_client_option()] | timeout().

Opens a TLS/DTLS connection.

    connect(TCPSocket, TLSOptions, Timeout).

Upgrades a `gen_tcp`, or equivalent, connected socket to a TLS socket, that is, performs the client-side TLS handshake.

    connect(Host, Port, TLSOptions).

Opens a TLS/DTLS connection and is equivalent to

    connect(Host, Port, TLSOptions, infinity).

Link to this function

# connect(Host, Port, TLSOptions, Timeout)

View Source

    -spec connect(Host, Port, TLSOptions, Timeout) ->
                     {ok, sslsocket()} |
                     {ok, sslsocket(), Ext :: protocol_extensions()} |
                     {error, reason()} |
                     {option_not_a_key_value_tuple, any()}
                     when
                         Host :: host(),
                         Port :: inet:port_number(),
                         TLSOptions :: [tls_client_option()],
                         Timeout :: timeout().

Opens a TLS/DTLS connection to `Host`, `Port`.

When the option `verify` is set to `verify_peer` the check `public_key:pkix_verify_hostname/2` will be performed in addition to the usual x509-path validation checks. If the check fails the error {bad_cert, hostname_check_failed} will be propagated to the path validation fun `verify_fun`, where it is possible to do customized checks by using the full possibilities of the `public_key:pkix_verify_hostname/3` API. When the option `server_name_indication` is provided, its value (the DNS name) will be used as `ReferenceID` to `public_key:pkix_verify_hostname/2`. When no `server_name_indication` option is given, the `Host` argument will be used as Server Name Indication extension. The `Host` argument will also be used for the `public_key:pkix_verify_hostname/2` check and if the `Host` argument is an `inet:ip_address()` the `ReferenceID` used for the check will be `{ip, Host}` otherwise `dns_id` will be assumed with a fallback to `ip` if that fails.

> #### Note

> According to good practices certificates should not use IP-addresses as "server names". It would be very surprising if this happened outside a closed network.

If the option `{handshake, hello}` is used the handshake is paused after receiving the server hello message and the success response is `{ok, SslSocket, Ext}` instead of `{ok, SslSocket}`. Thereafter the handshake is continued or canceled by calling `handshake_continue/3` or `handshake_cancel/1`.

If the option `active` is set to `once`, `true` or an integer value, the process owning the sslsocket will receive messages of type `active_msgs/0`

# Server API

Link to this function

# handshake(HsSocket)

View Source (since OTP 21.0)

    -spec handshake(HsSocket) -> {ok, SslSocket} | {ok, SslSocket, Ext} | {error, Reason}
                       when
                           HsSocket :: sslsocket(),
                           SslSocket :: sslsocket(),
                           Ext :: protocol_extensions(),
                           Reason :: closed | timeout | error_alert().

Performs the TLS/DTLS server-side handshake.

    hanshake(HsSocket).

Is equivalent to:

    handshake(HsSocket, infinity).

Link to this function

# handshake(HsSocket, OptionsOrTimeout)

View Source (since OTP 21.0)

    -spec handshake(HsSocket, OptionsOrTimeout) -> {ok, SslSocket} | {ok, SslSocket, Ext} | {error, Reason}
                       when
                           HsSocket :: sslsocket(),
                           OptionsOrTimeout :: timeout() | [server_option()],
                           SslSocket :: sslsocket(),
                           Ext :: protocol_extensions(),
                           Reason :: closed | timeout | error_alert().

Performs the TLS/DTLS server-side handshake.

    hanshake(HsSocket, Timeout).

Is equivalent to:

    handshake(HsSocket, [], Timeout).

and,

    hanshake(HsSocket, Options).

is equivalent to:

    handshake(HsSocket, Options, infinity).

Link to this function

# handshake(Socket, Options, Timeout)

View Source (since OTP 21.0)

    -spec handshake(Socket, Options, Timeout) -> {ok, SslSocket} | {ok, SslSocket, Ext} | {error, Reason}
                       when
                           Socket :: socket() | sslsocket(),
                           SslSocket :: sslsocket(),
                           Options :: [server_option()],
                           Timeout :: timeout(),
                           Ext :: protocol_extensions(),
                           Reason :: closed | timeout | {options, any()} | error_alert().

Performs the TLS/DTLS server-side handshake.

Returns a new TLS/DTLS socket if the handshake is successful.

If `Socket` is a ordinary `socket/0`: upgrades a `gen_tcp`, or equivalent, socket to an SSL socket, that is, performs the TLS server-side handshake and returns a TLS socket.

> #### Note

> The ordinary `Socket` shall be in passive mode ({active, false}) before calling this function, and before the client tries to connect with TLS, or else the behavior of this function is undefined. The best way to ensure this is to create the ordinary listen socket in passive mode.

If `Socket` is an sslsocket() : provides extra TLS/DTLS options to those specified in `listen/2` and then performs the TLS/DTLS handshake. Returns a new TLS/DTLS socket if the handshake is successful.

> #### Warning

> Not setting the timeout makes the server more vulnerable to DoS attacks.

If option `{handshake, hello}` is specified the handshake is paused after receiving the client hello message and the success response is `{ok, SslSocket, Ext}` instead of `{ok, SslSocket}`. Thereafter the handshake is continued or canceled by calling `handshake_continue/3` or `handshake_cancel/1`.

If the option `active` is set to `once`, `true` or an integer value, the process owning the sslsocket will receive messages of type `active_msgs/0`

Link to this function

# listen(Port, Options)

View Source

    -spec listen(Port, Options) -> {ok, ListenSocket} | {error, reason()}
                    when
                        Port :: inet:port_number(),
                        Options :: [tls_server_option()],
                        ListenSocket :: sslsocket().

Creates an SSL listen socket.

Link to this function

# transport_accept(ListenSocket)

View Source

    -spec transport_accept(ListenSocket) -> {ok, SslSocket} | {error, reason()}
                              when ListenSocket :: sslsocket(), SslSocket :: sslsocket().

Equivalent to `transport_accept(ListenSocket, infinity)`.

Link to this function

# transport_accept(ListenSocket, Timeout)

View Source

    -spec transport_accept(ListenSocket, Timeout) -> {ok, SslSocket} | {error, reason()}
                              when
                                  ListenSocket :: sslsocket(),
                                  Timeout :: timeout(),
                                  SslSocket :: sslsocket().

Accepts an incoming connection request on a listen socket.

`ListenSocket` must be a socket returned from `listen/2`. The socket returned is to be passed to handshake/1,2,3 to complete handshaking, that is, establishing the TLS/DTLS connection.

> #### Warning

> Most API functions require that the TLS/DTLS connection is established to work as expected.

The accepted socket inherits the options set for `ListenSocket` in `listen/2`.

The default value for `Timeout` is `infinity`. If `Timeout` is specified and no connection is accepted within the given time, `{error, timeout}` is returned.

# Client and Server API

Link to this function

# close(SslSocket)

View Source

    -spec close(SslSocket) -> ok | {error, Reason} when SslSocket :: sslsocket(), Reason :: any().

Closes a TLS/DTLS connection.

Link to this function

# close(SslSocket, How)

View Source (since OTP 18.1)

    -spec close(SslSocket, How) -> ok | {ok, port()} | {ok, port(), Data} | {error, Reason}
                   when
                       SslSocket :: sslsocket(),
                       How :: timeout() | {NewController :: pid(), timeout()},
                       Data :: binary(),
                       Reason :: any().

Closes or downgrades a TLS connection.

In the latter case the transport connection will be handed over to the `NewController` process after receiving the TLS close alert from the peer. The returned transport socket will have the following options set: `[{active, false}, {packet, 0}, {mode, binary}]`.

In case of downgrade, the close function might return some binary data that should be treated by the user as the first bytes received on the downgraded connection.

Link to this function

# controlling_process(SslSocket, NewOwner)

View Source

    -spec controlling_process(SslSocket, NewOwner) -> ok | {error, Reason}
                                 when SslSocket :: sslsocket(), NewOwner :: pid(), Reason :: any().

Assigns a new controlling process to the SSL socket.

A controlling process is the owner of an SSL socket, and receives all messages from the socket.

Link to this function

# handshake_cancel(Socket)

View Source (since OTP 21.0)

    -spec handshake_cancel(#sslsocket{fd :: term(), pid :: term()}) -> any().

Cancel the handshake with a fatal `USER_CANCELED` alert.

Link to this function

# handshake_continue(HsSocket, Options)

View Source (since OTP 21.0)

    -spec handshake_continue(HsSocket, Options) -> {ok, SslSocket} | {error, Reason}
                                when
                                    HsSocket :: sslsocket(),
                                    Options :: [tls_client_option() | tls_server_option()],
                                    SslSocket :: sslsocket(),
                                    Reason :: closed | timeout | error_alert().

Equivalent to `handshake_continue(HsSocket, Options, infinity)`.

Link to this function

# handshake_continue(HsSocket, Options, Timeout)

View Source (since OTP 21.0)

    -spec handshake_continue(HsSocket, Options, Timeout) -> {ok, SslSocket} | {error, Reason}
                                when
                                    HsSocket :: sslsocket(),
                                    Options :: [tls_client_option() | tls_server_option()],
                                    Timeout :: timeout(),
                                    SslSocket :: sslsocket(),
                                    Reason :: closed | timeout | error_alert().

Continue the TLS handshake, possibly with new, additional or changed options.

Link to this function

# recv(SslSocket, Length)

View Source

    -spec recv(SslSocket, Length) -> {ok, Data} | {error, reason()}
                  when
                      SslSocket :: sslsocket(),
                      Length :: non_neg_integer(),
                      Data :: binary() | list() | HttpPacket,
                      HttpPacket :: any().

Equivalent to `recv(Socket, Length, infinity)`.

Link to this function

# recv(SslSocket, Length, Timeout)

View Source

    -spec recv(SslSocket, Length, Timeout) -> {ok, Data} | {error, reason()}
                  when
                      SslSocket :: sslsocket(),
                      Length :: non_neg_integer(),
                      Data :: binary() | list() | HttpPacket,
                      Timeout :: timeout(),
                      HttpPacket :: any().

Receives a packet from a socket in passive mode.

A closed socket is indicated by return value `{error, closed}`. Argument `Length` is meaningful only when the socket is in mode `raw` and denotes the number of bytes to read. If `Length` = 0, all available bytes are returned. If `Length` > 0, exactly `Length` bytes are returned, or an error; possibly discarding less than `Length` bytes of data when the socket gets closed from the other side.

Optional argument `Timeout` specifies a time-out in milliseconds. The default value is `infinity`.

Link to this function

# send(SslSocket, Data)

View Source

    -spec send(SslSocket, Data) -> ok | {error, reason()} when SslSocket :: sslsocket(), Data :: iodata().

Writes `Data` to `SslSocket`.

A notable return value is `{error, closed}` indicating that the socket is closed.

Link to this function

# setopts(SslSocket, Options)

View Source

    -spec setopts(SslSocket, Options) -> ok | {error, reason()}
                     when SslSocket :: sslsocket(), Options :: [gen_tcp:option()].

Sets options according to `Options` for socket `SslSocket`.

Link to this function

# shutdown(SslSocket, How)

View Source (since OTP R14B)

    -spec shutdown(SslSocket, How) -> ok | {error, reason()}
                      when SslSocket :: sslsocket(), How :: read | write | read_write.

Immediately closes a socket in one or two directions.

`How == write` means closing the socket for writing, reading from it is still possible.

To be able to handle that the peer has done a shutdown on the write side, option `{exit_on_close, false}` is useful.

# TLS-1.3 Only API

Link to this function

# groups()

View Source (since OTP 27.0)

    -spec groups() -> [group()].

Returns all supported groups in TLS 1.3. Existed since OTP 22.0 , documented as of OTP 27.

Link to this function

# groups(Description)

View Source (since OTP 27.0)

    -spec groups(Description) -> [group()] when Description :: default.

Returns default supported groups in TLS 1.3. Existed since OTP 22.0, documented as of OTP 27.

Link to this function

# update_keys(SslSocket, Type)

View Source (since OTP 22.3)

    -spec update_keys(SslSocket, Type) -> ok | {error, reason()}
                         when SslSocket :: sslsocket(), Type :: write | read_write.

Create new session keys.

There are cryptographic limits on the amount of plaintext which can be safely encrypted under a given set of keys. If the amount of data surpasses those limits, a key update is triggered and a new set of keys are installed. See also the option key_update_at part of `common_option_tls13/0`.

This function can be used to explicitly start a key update on a TLS 1.3 connection. There are two types of the key update: if Type is set to write, only the writing key is updated; if Type is set to read_write, both the reading and writing keys are updated.

# Pre TLS-1.3 API

Link to this function

# eccs()

View Source (since OTP 19.2)

    -spec eccs() -> NamedCurves when NamedCurves :: [named_curve()].

Returns a list of all supported elliptic curves, including legacy curves, for all TLS/DTLS versions pre TLS-1.3.

Link to this function

# eccs(Version)

View Source (since OTP 19.2)

    -spec eccs(Version) -> NamedCurves
                  when
                      Version :: 'tlsv1.2' | 'tlsv1.1' | tlsv1 | 'dtlsv1.2' | dtlsv1,
                      NamedCurves :: [named_curve()].

Returns the by default supported elliptic curves for Version, which is a subset of what [eccs/[0]] returns.

Link to this function

# renegotiate(SslSocket)

View Source (since OTP R14B)

    -spec renegotiate(SslSocket) -> ok | {error, reason()} when SslSocket :: sslsocket().

Initiates a new handshake.

A notable return value is `{error, renegotiation_rejected}` indicating that the peer refused to go through with the renegotiation, but the connection is still active using the previously negotiated session.

TLS-1.3 has removed the renegotiate feature of earlier TLS versions and instead adds a new feature called key update that replaces the most important part of renegotiate, that is the refreshing of session keys. This is triggered automatically after reaching a plaintext limit and can be configured by option key_update_at part of `common_option_tls13/0`.

# Utility Functions

Link to this function

# append_cipher_suites(Deferred, Suites)

View Source (since OTP 20.3)

    -spec append_cipher_suites(Deferred, Suites) -> ciphers()
                                  when Deferred :: ciphers() | cipher_filters(), Suites :: ciphers().

Make `Deferred` suites become the least preferred suites.

That is put them at the end of the cipher suite list `Suites` after removing them from `Suites` if present. `Deferred` may be a list of cipher suites or a list of filters in which case the filters are use on `Suites` to extract the Deferred cipher list.

Link to this function

# cipher_suites(Description, Version)

View Source (since OTP 20.3)

    -spec cipher_suites(Description, Version) -> ciphers()
                           when
                               Description :: default | all | exclusive | anonymous | exclusive_anonymous,
                               Version :: protocol_version().

Lists all possible cipher suites corresponding to `Description` that are available.

The `exclusive` and `exclusive_anonymous` option will exclusively list cipher suites first supported in `Version` whereas the other options are inclusive from the lowest possible version to `Version`. The `all` options includes all suites except the anonymous and no anonymous suites are supported by default.

> #### Note

> TLS-1.3 has no overlapping cipher suites with previous TLS versions, that is the result of `cipher_suites(all, 'tlsv1.3').` contains a separate set of suites that can be used with TLS-1.3 an other set that can be used if a lower version is negotiated. PRE TLS-1.3 so called `PSK` and `SRP` suites need extra configuration to work that is the option `user_lookup_function`. No anonymous suites are supported by TLS-1.3.

> Also note that the cipher suites returned by this function are the cipher suites that the OTP ssl application can support provided that they are supported by the cryptolib linked with the OTP crypto application. Use ssl:filter_cipher_suites(Suites, []). to filter the list for the current cryptolib. Note that cipher suites may be filtered out because they are too old or too new depending on the cryptolib.

Link to this function

# cipher_suites(Description, Version, StringType)

View Source (since OTP 22.0)

    -spec cipher_suites(Description, Version, StringType) -> [string()]
                           when
                               Description :: default | all | exclusive | anonymous,
                               Version :: protocol_version(),
                               StringType :: rfc | openssl.

Same as `cipher_suites/2` but lists RFC or OpenSSL string names instead of `erl_cipher_suite/0`

Link to this function

# clear_pem_cache()

View Source (since OTP 17.5)

    -spec clear_pem_cache() -> ok.

Clears the PEM cache.

PEM files, used by ssl API-functions, are cached for performance reasons. The cache is automatically checked at regular intervals to see if any cache entries should be invalidated.

This function provides a way to unconditionally clear the entire cache, thereby forcing a reload of previously cached PEM files.

Link to this function

# connection_information(SslSocket)

View Source (since OTP 18.0)

    -spec connection_information(SslSocket) -> {ok, Result} | {error, reason()}
                                    when SslSocket :: sslsocket(), Result :: connection_info().

Returns the most relevant information about the connection.

Some items that are undefined will be filtered out. Note that values that affect the security of the connection will only be returned if explicitly requested by connection_information/2.

> #### Note

> The legacy `Item = cipher_suite` was removed in OTP 23. Previously it returned the cipher suite on its (undocumented) legacy format. It is replaced by `selected_cipher_suite`.

Link to this function

# connection_information(SslSocket, Items)

View Source (since OTP 18.0)

    -spec connection_information(SslSocket, Items) -> {ok, Result} | {error, reason()}
                                    when
                                        SslSocket :: sslsocket(),
                                        Items :: connection_info_keys(),
                                        Result :: connection_info().

Returns the requested information items about the connection, if they are defined.

Note that client_random, server_random, master_secret and keylog are values that affect the security of connection.

In order to retrieve keylog and other secret information from a TLS 1.3 connection, `keep_secrets` option must be configured in advance and set to `true`.

> #### Note

> If only undefined options are requested the resulting list can be empty.

Link to this function

# export_key_materials(SslSocket, Labels, Contexts, WantedLengths)

View Source (since OTP 27.0)

    -spec export_key_materials(SslSocket, Labels, Contexts, WantedLengths) ->
                                  {ok, ExportKeyMaterials} | {error, reason()}
                                  when
                                      SslSocket :: sslsocket(),
                                      Labels :: [binary()],
                                      Contexts :: [binary() | no_context],
                                      WantedLengths :: [non_neg_integer()],
                                      ExportKeyMaterials :: [binary()].

Equivalent to `export_key_materials(TLSSocket, Labels, Contexts, WantedLengths, true).`

Link to this function

# export_key_materials(SslSocket, Labels, Contexts, WantedLengths, ConsumeSecret)

View Source (since OTP 27.0)

    -spec export_key_materials(SslSocket, Labels, Contexts, WantedLengths, ConsumeSecret) ->
                                  {ok, ExportKeyMaterials} |
                                  {error, exporter_master_secret_already_consumed | bad_input}
                                  when
                                      SslSocket :: sslsocket(),
                                      Labels :: [binary()],
                                      Contexts :: [binary() | no_context],
                                      WantedLengths :: [non_neg_integer()],
                                      ConsumeSecret :: boolean(),
                                      ExportKeyMaterials :: [binary()].

Uses the Pseudo-Random Function, PRF (pre TLS-1.3) or HKDF (TLS-1.3), for a TLS connection to generate and export keying materials.

In TLS-1.3 using `no_context` is equivalent to specifying an empty context, that is an empty binary, pre TLS-1.3 these will render different results. The last argument is relevant only in TLS-1.3 and it causes the TLS-1.3 exporter_master_secret to be consumed that is it will no longer be available, to increase security, and further attempts to call this function will fail.

Link to this function

# filter_cipher_suites(Suites, Filters)

View Source (since OTP 20.3)

    -spec filter_cipher_suites(Suites, Filters) -> Ciphers
                                  when
                                      Suites :: ciphers(), Filters :: cipher_filters(), Ciphers :: ciphers().

Removes cipher suites if any of the filter functions returns false for any part of the cipher suite.

If no filter function is supplied for some part the default behaviour regards it as if there was a filter function that returned true. For examples see Customizing cipher suites . Additionally, this function also filters the cipher suites to exclude cipher suites not supported by the cryptolib used by the OTP crypto application. That is calling ssl:filter_cipher_suites(Suites, []) will be equivalent to only applying the filters for cryptolib support.

Link to this function

# format_error(Error)

View Source

    -spec format_error(Error) -> ReasonStr
                          when Error :: {error, reason()} | (Reason :: reason()), ReasonStr :: string().

Presents the error returned by an SSL function as a printable string, the error tag may be both included and excluded

Link to this function

# getopts(SslSocket, OptionNames)

View Source

    -spec getopts(SslSocket, OptionNames) -> {ok, [gen_tcp:option()]} | {error, reason()}
                     when SslSocket :: sslsocket(), OptionNames :: [gen_tcp:option_name()].

Gets the values of the specified socket options.

Link to this function

# getstat(SslSocket)

View Source (since OTP 19.0)

    -spec getstat(SslSocket) -> {ok, OptionValues} | {error, inet:posix()}
                     when SslSocket :: sslsocket(), OptionValues :: [{inet:stat_option(), integer()}].

Equivalent to `getstat/2`.

Link to this function

# getstat(SslSocket, Options)

View Source (since OTP 19.0)

    -spec getstat(SslSocket, Options) -> {ok, OptionValues} | {error, inet:posix()}
                     when
                         SslSocket :: sslsocket(),
                         Options :: [inet:stat_option()],
                         OptionValues :: [{inet:stat_option(), integer()}].

Gets one or more statistic options for the underlying TCP socket.

See inet:getstat/2 for statistic options description.

Link to this function

# negotiated_protocol(SslSocket)

View Source (since OTP 18.0)

    -spec negotiated_protocol(SslSocket) -> {ok, Protocol} | {error, Reason}
                                 when
                                     SslSocket :: sslsocket(),
                                     Protocol :: binary(),
                                     Reason :: protocol_not_negotiated | closed.

Returns the protocol negotiated through ALPN or NPN extensions.

Link to this function

# peercert(SslSocket)

View Source

    -spec peercert(SslSocket) -> {ok, Cert} | {error, reason()}
                      when SslSocket :: sslsocket(), Cert :: public_key:der_encoded().

The peer certificate is returned as a DER-encoded binary.

The certificate can be decoded with `public_key:pkix_decode_cert/2` Suggested further reading about certificates is public_key User's Guide and ssl User's Guide

Link to this function

# peername(SslSocket)

View Source

    -spec peername(SslSocket) -> {ok, {Address, Port}} | {error, reason()}
                      when
                          SslSocket :: sslsocket(), Address :: inet:ip_address(), Port :: inet:port_number().

Returns the address and port number of the peer.

Link to this function

# prepend_cipher_suites(Preferred, Suites)

View Source (since OTP 20.3)

    -spec prepend_cipher_suites(Preferred, Suites) -> ciphers()
                                   when Preferred :: ciphers() | cipher_filters(), Suites :: ciphers().

Make `Preferred` suites become the most preferred suites.

That is put them at the head of the cipher suite list `Suites` after removing them from `Suites` if present. `Preferred` may be a list of cipher suites or a list of filters in which case the filters are use on `Suites` to extract the preferred cipher list.

Link to this function

# signature_algs(Description, Version)

View Source (since OTP 26.0)

    -spec signature_algs(Description, Version) -> signature_algs()
                            when Description :: default | all | exclusive, Version :: protocol_version().

Lists all possible signature algorithms corresponding to `Description` that are available.

The `exclusive` option will exclusively list algorithms or algorithm schemes for that protocol version, whereas the `default` and `all` options lists the combined list to support the range of protocols from (D)TLS-1.2, the first version to support configuration of the signature algorithms, to `Version`.

Example:

          1> ssl:signature_algs(default, 'tlsv1.3').
          [eddsa_ed25519,eddsa_ed448,ecdsa_secp521r1_sha512,
          ecdsa_secp384r1_sha384,ecdsa_secp256r1_sha256,
          rsa_pss_pss_sha512,rsa_pss_pss_sha384,rsa_pss_pss_sha256,
          rsa_pss_rsae_sha512,rsa_pss_rsae_sha384,rsa_pss_rsae_sha256,
          rsa_pkcs1_sha512,rsa_pkcs1_sha384,rsa_pkcs1_sha256,
          {sha512,ecdsa},
          {sha384,ecdsa},
          {sha256,ecdsa}]

          2>ssl:signature_algs(all, 'tlsv1.3').
          [eddsa_ed25519,eddsa_ed448,ecdsa_secp521r1_sha512,
          ecdsa_secp384r1_sha384,ecdsa_secp256r1_sha256,
          rsa_pss_pss_sha512,rsa_pss_pss_sha384,rsa_pss_pss_sha256,
          rsa_pss_rsae_sha512,rsa_pss_rsae_sha384,rsa_pss_rsae_sha256,
          rsa_pkcs1_sha512,rsa_pkcs1_sha384,rsa_pkcs1_sha256,
          {sha512,ecdsa},
          {sha384,ecdsa},
          {sha256,ecdsa},
          {sha224,ecdsa},
          {sha224,rsa},
          {sha,rsa},
          {sha,dsa}]

          3> ssl:signature_algs(exclusive, 'tlsv1.3').
          [eddsa_ed25519,eddsa_ed448,ecdsa_secp521r1_sha512,
          ecdsa_secp384r1_sha384,ecdsa_secp256r1_sha256,
          rsa_pss_pss_sha512,rsa_pss_pss_sha384,rsa_pss_pss_sha256,
          rsa_pss_rsae_sha512,rsa_pss_rsae_sha384,rsa_pss_rsae_sha256]

> #### Note

> Some TLS-1-3 scheme names overlap with TLS-1.2 algorithm-tuple-pair-names and then TLS-1.3 names will be used, for example `rsa_pkcs1_sha256` instead of `{sha256, rsa}` these are legacy algorithms in TLS-1.3 that apply only to certificate signatures in this version of the protocol.

Link to this function

# sockname(SslSocket)

View Source

    -spec sockname(SslSocket) -> {ok, {Address, Port}} | {error, reason()}
                      when
                          SslSocket :: sslsocket(), Address :: inet:ip_address(), Port :: inet:port_number().

Returns the local address and port number of socket `SslSocket`.

Link to this function

# start()

View Source (since OTP R14B)

    -spec start() -> ok | {error, reason()}.

Equivalent to `start(temporary)`.

Link to this function

# start(Type)

View Source (since OTP R14B)

    -spec start(permanent | transient | temporary) -> ok | {error, reason()}.

Starts the SSL application.

Link to this function

# stop()

View Source (since OTP R14B)

    -spec stop() -> ok.

Stops the SSL application.

Link to this function

# str_to_suite(CipherSuiteName)

View Source (since OTP 22.0)

    -spec str_to_suite(CipherSuiteName) -> erl_cipher_suite() | {error, {not_recognized, CipherSuiteName}}
                          when CipherSuiteName :: string().

Converts an RFC or OpenSSL name string to an `erl_cipher_suite/0`

Returns an error if the cipher suite is not supported or the name is not a valid cipher suite name.

Link to this function

# suite_to_openssl_str(CipherSuite)

View Source (since OTP 22.0)

    -spec suite_to_openssl_str(CipherSuite) -> string() when CipherSuite :: erl_cipher_suite().

Converts `erl_cipher_suite/0` to OpenSSL name string.

PRE TLS-1.3 these names differ for RFC names

Link to this function

# suite_to_str(CipherSuite)

View Source (since OTP 21.0)

    -spec suite_to_str(CipherSuite) -> string() when CipherSuite :: erl_cipher_suite().

Converts an `erl_cipher_suite()` value to an RFC name string.

Link to this function

# versions()

View Source (since OTP R14B)

    -spec versions() -> [VersionInfo]
                      when
                          VersionInfo ::
                              {ssl_app, string()} |
                              {supported | available | implemented, [tls_version()]} |
                              {supported_dtls | available_dtls | implemented_dtls, [dtls_version()]}.

Lists information, mainly concerning TLS/DTLS versions, in runtime for debugging and testing purposes.

- `app_vsn` - The application version of the SSL application.

- `supported` - TLS versions supported with current application environment and crypto library configuration. Overridden by a version option on connect/2,3,4, `listen/2`, and handshake/2,3. For the negotiated TLS version, see connection_information/1 .

- `supported_dtls` - DTLS versions supported with current application environment and crypto library configuration. Overridden by a version option on connect/2,3,4, `listen/2`, and handshake/2,3. For the negotiated DTLS version, see connection_information/1 .

- `available` - All TLS versions supported with the linked crypto library.

- `available_dtls` - All DTLS versions supported with the linked crypto library.

- `implemented` - All TLS versions supported by the SSL application if linked with a crypto library with the necessary support.

- `implemented_dtls` - All DTLS versions supported by the SSL application if linked with a crypto library with the necessary support.

# Deprecated API

Link to this function

# prf(SslSocket, Secret, Label, Seed, WantedLength)

View Source (since OTP R15B01)
This function is deprecated. ssl:prf/5 is deprecated; Use export_key_materials/4 instead. Note that in OTP 28 the 'testing' way of calling this function will no longer be supported..

    -spec prf(SslSocket, Secret, Label, Seed, WantedLength) -> {ok, binary()} | {error, reason()}
                 when
                     SslSocket :: sslsocket(),
                     Secret :: binary() | master_secret,
                     Label :: binary(),
                     Seed :: [binary() | prf_random()],
                     WantedLength :: non_neg_integer().

Uses the Pseudo-Random Function (PRF) of a TLS session to generate extra key material.

It either takes user-generated values for `Secret` and `Seed` or atoms directing it to use a specific value from the session security parameters.

> #### Note

> This function is replaced by `export_key_materials/4`, official documented API function since OTP 27, which is equivalent to `prf(TLSSocket, master_secret, Label, [client_random, server_random, Context], WantedLength)` Other ways of calling this function was for testing purposes only and has no use case. Called in TLS-1.3 context it will now behave as `export_key_materials(TLSSocket, [Label], [Context], [WantedLength])`